using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Compensation
{
    [ServiceContract]
    [DeliveryRequirements(QueuedDeliveryRequirements 
        = QueuedDeliveryRequirementsMode.Required)]
    public interface ICompensate
    {
        [OperationContract(IsOneWay=true,Action="*")]
        void Compensate(Message input);
    }

    public class CompensationClient : ClientBase<ICompensate>, ICompensate
    {
        public CompensationClient(string endpointConfigurationName)
            : base(endpointConfigurationName)
        {
        }

        public void Compensate(Message input)
        {
            base.Channel.Compensate(input);
        }

        
    }
}
