using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace SecurityTokenService
{
    public sealed partial class ClaimMappingWorkflow : SequentialWorkflowActivity
    {
        private string requestIdentifier = null;
        private string[] inputClaims = null;
        private List<string> outputClaims = new List<string>();

        public ClaimMappingWorkflow()
        {
            InitializeComponent();
        }

        public string RequestIdentifier
        {
            get
            {
                return this.requestIdentifier;
            }

            set
            {
                this.requestIdentifier = value;
            }
        }

        public string[] InputClaims
        {
            get
            {
                return this.inputClaims;
            }

            set
            {
                this.inputClaims = value;
            }
        }

        public string[] OutputClaims
        {
            get
            {
                return this.outputClaims.ToArray();
            }


        }

        private void ReplicationManager_ChildInitialized(object sender, 
            ReplicatorChildEventArgs e)
        {
            ClaimMappingActivity child = (ClaimMappingActivity)e.Activity;
            child.InputClaim = (string)e.InstanceData;
        }

        private void ReplicationManager_Initialized(object sender, EventArgs e)
        {
            foreach (string inputClaim in this.InputClaims)
            {
                this.ReplicationManager.CurrentChildData.Add(inputClaim);
            }
        }

        private void ReplicationManager_Completed(object sender, EventArgs e)
        {

        }

        private void ReplicationManager_ChildCompleted(object sender, 
            ReplicatorChildEventArgs e)
        {
            ClaimMappingActivity child = (ClaimMappingActivity)e.Activity;
            this.outputClaims.Add((string)child.OutputClaim);
        }

        
    }

}

