using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;

namespace Service
{
    public class OperationRequirementsConfigurationSection : ConfigurationSection
    {
        public OperationRequirementsConfigurationSection()
        {
        }

        [ConfigurationProperty("", IsDefaultCollection = true)]
        public OperationRequirementsCollection OperationRequirements
        {
            get
            {
                return (OperationRequirementsCollection)base[""];
            }
        }
    }

    public class OperationRequirementsCollection : ConfigurationElementCollection
    {
        protected override ConfigurationElement CreateNewElement()
        {
            return new OperationElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((OperationElement)element).Identifier;
        }

        public override ConfigurationElementCollectionType CollectionType
        {
            get
            {
                return ConfigurationElementCollectionType.BasicMap;
            }
        }

        protected override string ElementName
        {
            get
            {
                return "operation";
            }
        }
    }

    public class OperationElement : ConfigurationElement
    {
        [ConfigurationProperty("identifier", IsKey = true, IsRequired = true)]
        public string Identifier
        {
            get
            {
                return (string)base["identifier"];
            }
            set
            {
                base["identifier"] = value;
            }
        }

        [ConfigurationProperty("", IsDefaultCollection = true)]
        public RolesCollection Roles
        {
            get
            {
                return (RolesCollection)base[""];
            }
        }

    }

    public class RolesCollection : ConfigurationElementCollection
    {
        protected override ConfigurationElement CreateNewElement()
        {
            return new RoleElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((RoleElement)element).Name;
        }

        public override ConfigurationElementCollectionType CollectionType
        {
            get
            {
                return ConfigurationElementCollectionType.BasicMap;
            }
        }

        protected override string ElementName
        {
            get
            {
                return "role";
            }
        }
    }

    public class RoleElement : ConfigurationElement
    {
        [ConfigurationProperty("name", IsKey = true, IsRequired = true)]
        public string Name
        {
            get
            {
                return (string)base["name"];
            }
            set
            {
                base["name"] = value;
            }
        }

        

    }

}
