using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;

namespace Extensibility
{
	public class MyCustomChannelBindingElement: BindingElement
	{
		public MyCustomChannelBindingElement():base()
		{
		}

		public MyCustomChannelBindingElement(MyCustomChannelBindingElement that):base(that)
		{
		}

		public override BindingElement Clone()
		{
			return new MyCustomChannelBindingElement(this);	
		}

		public override T GetProperty<T>(BindingContext context)
		{
			return context.GetInnerProperty<T>();
		}

		public override bool CanBuildChannelListener<TChannel>(BindingContext context)
		{
			if (typeof(TChannel) == typeof(IInputChannel))
			{
				return true;
			}
			if (typeof(TChannel) == typeof(IOutputChannel))
			{
				return true;
			}
			return false;
		}

		public override IChannelListener<TChannel> BuildChannelListener<TChannel>(BindingContext context) 
		{
			MyCustomChannelListener<TChannel> listener = new MyCustomChannelListener<TChannel>();
			listener.InnerChannelListener = context.BuildInnerChannelListener<TChannel>();
			return listener;
		}

		public override IChannelFactory<TChannel> BuildChannelFactory<TChannel>(BindingContext context)
		{
			MyCustomChannelFactory<TChannel> channelFactory = new MyCustomChannelFactory<TChannel>();
			channelFactory.InnerChannelFactory = context.BuildInnerChannelFactory<TChannel>();
			return channelFactory;
		}
	}
}
