using System;
using System.IO;
using System.Xml;
using System.Text;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace Extensibility
{
    public class MyCustomMessageEncoder : MessageEncoder
    {
        private MessageVersion version = null;

        private MyCustomMessageEncoder()
        {
        }

        public MyCustomMessageEncoder(MyCustomMessageEncoderFactory factory)
        {
            this.version = factory.MessageVersion;
        }

        public override string ContentType
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public override string MediaType
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public override MessageVersion MessageVersion
        {
            get 
            {
                return this.version;
            }
        }

        public override Message ReadMessage(ArraySegment<byte> buffer, BufferManager bufferManager, string contentType)
        {
            Console.WriteLine("Reading an incoming message.");

            return Message.CreateMessage(this.MessageVersion, "*", Encoding.ASCII.GetString(buffer.Array, 0, buffer.Array.Length));
            
        }

        public override Message ReadMessage(Stream stream, int maxSizeOfHeaders, string contentType)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public override ArraySegment<byte> WriteMessage(Message message, int maxMessageSize, BufferManager bufferManager, int messageOffset)
        {
            string messageBody = message.GetBody<XmlElement>().InnerText;
            return new ArraySegment<byte>(ASCIIEncoding.ASCII.GetBytes(messageBody), messageOffset, messageBody.Length);
            
        }

        public override void WriteMessage(Message message, Stream stream)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        
    }
}
