using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Service
{
	public class CustomStream: Stream
	{
		private string backingStore = null;
		private FileStream backingStream = null;
		private bool initialRead = true;
		private DateTime startRead;
		private long totalBytes = 0;

		private CustomStream()
		{
		}

		public CustomStream(string fileName)
		{
			this.backingStore = fileName;
		}

		public override bool CanRead
		{
			get { throw new Exception("The method or operation is not implemented."); }
		}

		public override bool CanSeek
		{
			get { throw new Exception("The method or operation is not implemented."); }
		}

		public override bool CanWrite
		{
			get { throw new Exception("The method or operation is not implemented."); }
		}

		public override void Flush()
		{
			throw new Exception("The method or operation is not implemented.");
		}

		public override long Length
		{
			get { throw new Exception("The method or operation is not implemented."); }
		}

		public override long Position
		{
			get
			{
				throw new Exception("The method or operation is not implemented.");
			}
			set
			{
				throw new Exception("The method or operation is not implemented.");
			}
		}

		public override int Read(byte[] buffer, int offset, int count)
		{
			TimeSpan duration;

			if (this.initialRead)
			{
				this.startRead = DateTime.Now;
				this.initialRead = false;
			}
			else
			{
				Thread.Sleep(100);
			}
			
			Console.WriteLine(string.Format("Reading {0} bytes from backing store.", count));

			if (this.backingStream == null)
			{
				this.backingStream = new FileStream(this.backingStore, FileMode.Open);
			}

			int bytesRead = this.backingStream.Read(buffer, offset, count);

			if (bytesRead <= 0)
			{
				this.backingStream.Close();
			}

			this.totalBytes += bytesRead;

			duration = (DateTime.Now - this.startRead);

			Console.WriteLine("Sent {0} bytes in {1}:{2}.", this.totalBytes, duration.Seconds, duration.Milliseconds);
			
			return bytesRead;
		}

		public override long Seek(long offset, SeekOrigin origin)
		{
			throw new Exception("The method or operation is not implemented.");
		}

		public override void SetLength(long value)
		{
			throw new Exception("The method or operation is not implemented.");
		}

		public override void Write(byte[] buffer, int offset, int count)
		{
			throw new Exception("The method or operation is not implemented.");
		}
}
}
